<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../Date.xsl" />
<xsl:output method="text"/>

<xsl:template match="/softworkbench">
<xsl:variable name="table">
	<xsl:value-of select="@Table" />
</xsl:variable>
<xsl:variable name="package"><xsl:value-of select="$table"/>_PKG</xsl:variable>
------------------------------------------------------------------------------------------------------
--Package was auto-generated by Softworkbench.SPGenerator
--Generated time: <xsl:value-of select="$date" />
--Web: http://www.softworkbench.com
--Email: support@softworkbench.com
------------------------------------------------------------------------------------------------------

--===============================================================
--[Package generated for table: <xsl:value-of select="$table"/>]

--Begin Package header
CREATE OR REPLACE PACKAGE <xsl:value-of select="$package"/> AS

<xsl:text>&#x9;</xsl:text>TYPE cursor_type IS REF CURSOR;<xsl:text>&#xA;</xsl:text>
	<xsl:apply-templates select="//procedure" mode="proc">
		<xsl:with-param name="tablename"><xsl:value-of select="$table"/></xsl:with-param>
	</xsl:apply-templates>
END <xsl:value-of select="$package"/>;
--End Package header
/

--Begin Package body
CREATE OR REPLACE PACKAGE BODY <xsl:value-of select="$package"/> AS<xsl:text>&#xA;</xsl:text>
	<xsl:apply-templates select="//procedure" mode="body">
		<xsl:with-param name="tablename"><xsl:value-of select="$table"/></xsl:with-param>
	</xsl:apply-templates>
END <xsl:value-of select="$package"/>;
--End Package body
/
--[End of Package for table: <xsl:value-of select="$table"/>]
--===============================================================
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="procedure" mode="proc">
<xsl:param name="tablename"/>
<xsl:text>&#x9;</xsl:text>PROCEDURE <xsl:value-of select="@name"/><xsl:text>&#xA;</xsl:text>
<xsl:text>&#x9;</xsl:text>(<xsl:text>&#xA;</xsl:text>
	<xsl:choose >
		<xsl:when test='@type="READALL"' ><xsl:text>&#x9;</xsl:text><xsl:text>&#x9;</xsl:text>p_cur OUT cursor_type</xsl:when>
		<xsl:when test='@type="READ"' ><xsl:text>&#x9;</xsl:text><xsl:text>&#x9;</xsl:text>p_cur OUT cursor_type,<xsl:text>&#xA;</xsl:text>
			<xsl:apply-templates select="//primarykey" mode="pk">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="DELETE"'>
			<xsl:apply-templates select="//primarykey" mode="pk">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="READALLFK"'><xsl:text>&#x9;</xsl:text><xsl:text>&#x9;</xsl:text>p_cur OUT cursor_type,<xsl:text>&#xA;</xsl:text>
			<xsl:text>&#x9;</xsl:text><xsl:text>&#x9;p_</xsl:text>
			<xsl:value-of select="foreignkey//@name"/> IN <xsl:value-of select="$tablename"/>.<xsl:value-of select="foreignkey//@name"/>%TYPE
		</xsl:when>
		<xsl:when test='@type="UPDATE"'>
			<xsl:apply-templates select="//primarykey" mode="pk">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>,
			<xsl:apply-templates select="parameters//parameter" mode="param">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
				<xsl:with-param name="proctype"><xsl:value-of select="@type"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:otherwise > 
			<xsl:apply-templates select="parameters//parameter" mode="param">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
				<xsl:with-param name="proctype"><xsl:value-of select="@type"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:otherwise>
	</xsl:choose>
<xsl:text>&#xA;</xsl:text><xsl:text>&#x9;</xsl:text>);
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="procedure" mode="body">
<xsl:param name="tablename"/>
	<xsl:choose >
		<xsl:when test='@type="READALL"'>
			<xsl:apply-templates select="//procedure" mode="readall">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="READ"'>
			<xsl:apply-templates select="//procedure" mode="read">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="INSERT"'>
			<xsl:apply-templates select="//procedure" mode="insert">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="UPDATE"'>
			<xsl:apply-templates select="//procedure" mode="update">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="DELETE"'>
			<xsl:apply-templates  select="//procedure" mode="delete">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="READALLFK"'>
	-- //// Read all Stored Procedure based on foreign key
	PROCEDURE <xsl:value-of select="@name"/>
	(
		p_cur OUT cursor_type,
		p_<xsl:value-of select="foreignkey//@name" /> IN <xsl:value-of select="$tablename"/>.<xsl:value-of select="foreignkey//@name"/>%TYPE
	)
	AS
	BEGIN
		open p_cur for
		select	<xsl:for-each select="parameters//parameter">
			<xsl:value-of select="@name"/>
			<xsl:if test="not(position()=last())">,
  				</xsl:if>
			</xsl:for-each>
		from	<xsl:value-of select="$tablename"/>
		WHERE <xsl:value-of select="foreignkey//@name"/> = p_<xsl:value-of select="foreignkey//@name"/>;
	END;
		</xsl:when>
	</xsl:choose>
</xsl:template>

<xsl:template match="procedure" mode="delete">
<xsl:param name="tablename"/>
	<xsl:if test='@type="DELETE"'>
	-- //// Delete Stored Procedure based on primary keys
	PROCEDURE <xsl:value-of select="@name"/>
	(
		<xsl:for-each select="//primarykey">
		<xsl:text>p_</xsl:text><xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
		<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:for-each>
	)
	AS
	BEGIN
		delete from	<xsl:value-of select="$tablename"/>
		where <xsl:apply-templates select="//primarykey" mode="pkwhereclause"/>;
	END;
	</xsl:if>
</xsl:template>

<xsl:template match="procedure" mode="insert">
<xsl:param name="tablename"/>
	<xsl:if test='@type="INSERT"'>
	-- //// Insert Stored Procedure
	PROCEDURE <xsl:value-of select="@name"/>
	(
		<xsl:for-each select="parameters//parameter">
		<xsl:choose >
		<xsl:when test='@isIdentity="TRUE"'>
		p_<xsl:value-of select="@name"/> OUT <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE,<xsl:text />
		</xsl:when>
		<xsl:otherwise > 
		p_<xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
		<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:for-each>
	)
	AS
		<xsl:for-each select="parameters//parameter">
		<xsl:if test='@isIdentity="TRUE"'>
		<xsl:text/>num_<xsl:value-of select="@name"/><xsl:text> NUMBER;</xsl:text>
		</xsl:if>
		</xsl:for-each>
	BEGIN
		<xsl:for-each select="parameters//parameter">
		<xsl:if test='@isIdentity="TRUE"'>
		<xsl:text/>select <xsl:value-of select="@SequenceName"/>.NEXTVAL
		into num_<xsl:value-of select="@name"/>
		from DUAL;
		</xsl:if>
		</xsl:for-each>
		insert into <xsl:value-of select="$tablename"/>
		(
			<xsl:for-each select="parameters//parameter">
			<xsl:value-of select="@name"/>
			<xsl:if test="not(position()=last())">,
  			</xsl:if>
			</xsl:for-each>
		)
		values
		(
			<xsl:for-each select="parameters//parameter">
			<xsl:choose>
			<xsl:when test='@isIdentity="TRUE"'>
			num_<xsl:value-of select="@name"/><xsl:text>,&#xA;</xsl:text>
			</xsl:when>
			<xsl:otherwise>
			<xsl:text>&#x9;&#x9;&#x9;p_</xsl:text><xsl:value-of select="@name"/>
			<xsl:if test="not(position()=last())"><xsl:text>,&#xA;</xsl:text></xsl:if>
			</xsl:otherwise>
			</xsl:choose>
			</xsl:for-each>
		);
		
		<xsl:for-each select="parameters//parameter[@isIdentity='TRUE']">
		<xsl:text/>p_<xsl:value-of select="@name"/> := num_<xsl:value-of select="@name"/>;
		</xsl:for-each>
	END;
	</xsl:if>
</xsl:template>

<xsl:template match="procedure" mode="update">
<xsl:param name="tablename"/>
	<xsl:if test='@type="UPDATE"'>
	-- //// Update Stored Procedure based on primary keys
	PROCEDURE <xsl:value-of select="@name"/>
	(
		<xsl:for-each select="//primarykey">
		<xsl:text>p_</xsl:text><xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
		<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:for-each>,
		<xsl:for-each select="parameters//parameter">
		p_<xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
		<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:for-each>
	)
	AS
	BEGIN
		update <xsl:value-of select="$tablename"/> set 	
		<xsl:for-each select="parameters//parameter">
			<xsl:value-of select="@name"/> = p_<xsl:value-of select="@name"/><xsl:if test="not(position()=last())">, </xsl:if>
		</xsl:for-each>
		where <xsl:apply-templates select="//primarykey" mode="pkwhereclause"/>;
	END;
	</xsl:if>
</xsl:template>


<xsl:template match="procedure" mode="readall">
<xsl:param name="tablename"/>
	<xsl:if test='@type="READALL"'>
	-- //// Select All Stored Procedures
	PROCEDURE <xsl:value-of select="@name"/> (p_cur OUT cursor_type)
	AS
	BEGIN
		open p_cur for
		select	<xsl:for-each select="parameters//parameter">
			<xsl:value-of select="@name"/>
			<xsl:if test="not(position()=last())">,
  				</xsl:if>
			</xsl:for-each>
		from	<xsl:value-of select="$tablename"/>;
	END;
	</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="procedure" mode="read">
<xsl:param name="tablename"/>
	<xsl:if test='@type="READ"'>
	-- //// Read Stored Procedure based on primary keys
	PROCEDURE <xsl:value-of select="@name"/>
	(
		p_cur OUT cursor_type,
		<xsl:for-each select="//primarykey">
		<xsl:text>p_</xsl:text><xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
		<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:for-each>
	)
	AS
	BEGIN
		open p_cur for
		select	<xsl:for-each select="parameters//parameter">
			<xsl:value-of select="@name"/>
			<xsl:if test="not(position()=last())">,
  				</xsl:if>
			</xsl:for-each>
		from	<xsl:value-of select="$tablename"/>
		where <xsl:apply-templates select="//primarykey" mode="pkwhereclause"/>;
	END;
	</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="parameters//parameter" mode="param">
<xsl:param name="tablename"/>
<xsl:param name="proctype"/>
<xsl:choose >
<xsl:when test='$proctype="INSERT"' >
<xsl:choose >
<xsl:when test='@isIdentity="TRUE"'>
<xsl:text>&#x9;</xsl:text><xsl:text>&#x9;p_</xsl:text><xsl:text />
<xsl:value-of select="@name"/> OUT <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE,<xsl:text />
<xsl:text>&#xA;</xsl:text></xsl:when>
<xsl:otherwise>
<xsl:text>&#x9;</xsl:text><xsl:text>&#x9;p_</xsl:text><xsl:text />
<xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
<xsl:if test="not(position()=last())">,<xsl:text>&#xA;</xsl:text></xsl:if>
</xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:when  test='$proctype="UPDATE"' >
<xsl:text>&#x9;</xsl:text><xsl:text>&#x9;p_</xsl:text><xsl:text />
<xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename" />.<xsl:value-of select="@name"/>%TYPE<xsl:text />
<xsl:if test="not(position()=last())">,<xsl:text>&#xA;</xsl:text></xsl:if>
</xsl:when>
</xsl:choose>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="primarykey" mode="pk">
<xsl:param name="tablename"/>
<xsl:text>&#x9;</xsl:text><xsl:text>&#x9;p_</xsl:text><xsl:text />
<xsl:value-of select="@name"/> IN <xsl:value-of select="$tablename"/>.<xsl:value-of select="@name"/>%TYPE<xsl:text />
<xsl:if test="not(position()=last())">,</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="primarykey" mode="pkwhereclause">
<xsl:param name="tablename"/>
<xsl:text> </xsl:text><xsl:value-of select="@name"/> = p_<xsl:value-of select="@name"/><xsl:if test="not(position()=last())"> and </xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
</xsl:stylesheet>

<!-- Copyright (c) Softworkbench, Inc., 2015 All Rights Reserved.-->
